#!/usr/local/bin/perl -w

sub usage {
    warn(
	 "Usage: makejoule.pl [-round]   [<filename>...]+\n");
    exit 1;
}

sub arguments {
    $dontround = 1;
    while ($#ARGV >= 0) {
	$_ = shift @ARGV;
	if (/^-/) {
	    if ($_ eq substr("-round", 0, length $_)) {
		$dontround = 0;
	    } else {
		&usage();
	    }
	}
	else {
	    unshift @ARGV,$_;
	    last;
	}
    }
}

%runtimes = (
"tts206high",  "  371",
"tts192high",  "  372",
"tts177high",  "  372",
"tts162high",  "  374",
"tts147high",  "  376",
"tts133high",  "  377",
"tts118high",  "  379",
"tts103high",  "  384",
"tts88high",  "  391",
"tts74high",  "  434",
"tts88low",  "  391",
"tts74low",  "  434",
	     );

sub pline {
    local($itsy) = shift;
    local($tmp) = shift;
    local($Pavg) = shift;
    local($Eavg) = shift;
    local($Rerr) = shift;
    printf "itsy \#$itsy, %28s ", $tmp;
    printf 
	"Pavg %10s mW, Eavg %10s J, RErr %.${p}f%%\n", sprintf("%3.6f",$Pavg), sprintf("%3.6f",$Eavg), $Rerr;
}

sub processit { # IN_FILEHANDLE 
    local($IN) = shift;

    $p = 6;
    $p = 2 if (!$dontround);

    while(<$IN>) {
	next if (/mismatch/);
	next if (/0 voltage measured/);
	($itsy, $command, $condition, $uid, $Pavg, $Rerr) = 
	    $_ =~ /^itsy \#(\d+),\s+(\S+)-(\S+):(\S+)\s*Pavg\s+(\S+)\s+mW,\s+R[eE]rr\s+(\S+)%\s+/;
	next if (!($command =~ /tts/));
#	printf STDERR "$itsy, $command, $condition, $uid, $Pavg, $Rerr\n";

	$runtime = $runtimes{$command};
	
	$tmp = $command."-".$condition.":".$uid;
	pline($itsy, $tmp, $Pavg, $Pavg*$runtime/1000, $Rerr);

    }
}


&arguments();

FILE:

if ($#ARGV < 0) {
    &usage();
}

while ($#ARGV >= 0) {
    $infile = shift @ARGV;
    open(FILE, $infile) || (die "Can't open $infile: $!\n");
    
    processit(FILE);
    close(FILE);

}
