#!/usr/local/bin/perl -w

sub usage {
    warn(
	 "Usage: ptimes.pl [-pall]\n" .
	 "  [<filename>...]\n");
    exit 1;
}

sub arguments {
    $pall = 0;
    while ($#ARGV >= 0) {
	$_ = shift @ARGV;
	if (/^-/) {
	    if ($_ eq substr("-pall", 0, length $_)) {
		$pall = 1;
	    } else {
		&usage();
	    }
	}
	else {
	    unshift @ARGV,$_;
	    last;
	}
    }
}

sub processit { # IN_FILEHANDLE 
    local($IN) = $_[0];

    @itmp = split('/', $infile);

    $last_Tstart_a = 0;
    $min = 100;
    $max = 0;

    ($itsy, $type) = $itmp[$#itmp-1] =~ /^(\d+)(\D.+)$/;
    $itsy = "000" if (! $itsy);
    $type = "" if (! $type);

    while(<$IN>) {
	next if (/^\#/);
	if (/^(\S+)\s/) {
	    $Tstart_a = $1;
	    if ($last_Tstart_a > 0) {
		$diff = $Tstart_a - $last_Tstart_a;
		printf "$Tstart_a %f\n", $diff if $pall;
		if ($diff < $min) {
		    $min = $diff;
		    $mint = $Tstart_a;
		}
		if ($diff > $max) {
		    $max = $diff;
		    $maxt = $Tstart_a;
		}
	    }
	    $last_Tstart_a = $Tstart_a;
	}
    }
    printf "$infile min: %f (at %f)\n", $min, $mint;
    printf "$infile max: %f (at %f)\n", $max, $maxt;
}

&arguments();

FILE:

if ($#ARGV < 0) {
    &usage();
}

while ($#ARGV >= 0) {
    $infile = shift @ARGV;
    open(FILE, $infile) || (die "Can't open $infile: $!\n");
    
    if ($infile =~ /\.gz/) {
	close(FILE);
	open(FILE, "gzcat $infile |") || (die "gzcat of $infile failed: $!\n");
    }

    processit(FILE);

    close(FILE);

}
