#!/usr/local/bin/perl -w

$echar_sleep = .020;  
$echar_notsleep = .080;
$nbint = 150;

#               name          Tres
%program_info = (
"sleep",           "sleep#"       . "3600",
"deepsleep",       "deepsleep#"   . "3600",
"sleeplcd",        "sleeplcd#"    . "3600",
"sleepdc",         "sleepdc#"     . "3600",
"mpeg206high",     "mpeg206high#" .  " 90",
"dectalk74low",    "tts74low#"    .  "195",
"dectalk74high",   "tts74high#"   .  "195",
"dectalk206high",  "tts206high#"  .  "195",
"wav59high",       "wav59high#"   .  "252",
"wav206high",      "wav206high#"  .  "252",
"idle59low",       "idle59low#"   .  "600",
"idle59high",      "idle59high#"  .  "600",
"idle133high",     "idle133high#" .  "600",
"idle206high",     "idle206high#" .  "600",
"natspeak206high", "dict206high#" .  "102",
);

sub usage {
    warn("Usage: gpgin [-nbint <number>] [-forcemaxt <seconds>] <filename>+\n");
    exit 1;
}

sub arguments {
    $forcemaxt = "";
    while ($#ARGV >= 0) {
	$_ = shift @ARGV;
	if (/^-/) {
	    if ($_ eq substr("-nbint", 0, length $_)) {
		$nbint = shift @ARGV;
	    } elsif ($_ eq substr("-forcemaxt", 0, length $_)) {
		$forcemaxt = shift @ARGV;
		$forcemaxt = "-forcemaxt " . $forcemaxt . " ";
	    } else {
		&usage();
	    }
	}
	else {
	    unshift @ARGV,$_;
	    last;
	}
    }
}

sub processit { # IN_FILEHANDLE 
    local($IN) = $_[0];
    local($pathname) = $_[1];

    $battery = 0;
    open(BFILE, "$pathname/STATS") || (die "Can't open $pathname/STATS: $!\n");
    while (<BFILE>) {
	if (/^Itsy \#\d+, battery\s+#(\d+)\D/) {
	    $battery = $1;
	    last;
	}
    }
    close(BFILE);

    while(<$IN>) {
	if (/^running command .\/doit  (\w+)\s+-speed\s+(\d+) -(\w+) (.+)$/) {
	    $prefix = $1;
	    $command_index = sprintf("%s%d%s", $1, $2, $3);
	    $rest = $4;
	    if ($prefix =~ /sleep/) {
		$command_index = $prefix;
	    }
	    if ($rest =~ /-noprint/) {
		$printstr = "-noprint";
	    }
	    $tmp = $program_info{$command_index};
	    if ($tmp) {
		@tmp = split(/\#/, $program_info{$command_index});
		$command = $tmp[0];
		$tres = $tmp[1];
	    }
	    else {
		$tres = -1;
		if ($command_index =~ /^dectalk(.+)$/) {
		    $command = "tts" . $1;
		}
		elsif ($command_index =~ /^natspeak(.+)$/) {
		    $command = "dict" . $1;
		} 
		else {
		    $command = $command_index;
		}
	    }
	    $nchars = 0;
	    @outfiles = ();
	}
	elsif (/^\w+\s+(\w+)\s+(\d+)\s+(\d+):(\d+):(\d+)\s+P.T (\d+):  \+\s*$/) {
	    # eventually will be absolute time last character was seen
	    $nchars++;
	}
	elsif ($command && (/labinstr.*\/($command\.[a-z]+\.\d+\.out) /)) {
	    push(@outfiles, $1);
	}
	elsif (/^Experiment seemed to take (\d+) seconds/) {

	    foreach $outfile (@outfiles) {

		($junk1, $host, $junk2, $junk3) = split('\.', $outfile);

		if ($outfile =~ /sleep/) {
		    $echar = $echar_sleep;
		}
		else {
		    $echar = $echar_notsleep;
		}

		printf "/udir/kerr/measurements/power/bin-full/pwrgraph " .
		    "-noround -tres %d -nchars %d -echar %f -nbint %d -host %s %s %s%s/%s\n",
		    $tres, $nchars-1, $echar, $nbint, $host, $printstr, $forcemaxt,
		    $pathname, $outfile;
	    }


	}
    }

}

$printstr = "";

FILE:
if ($#ARGV < 0) {
    &usage();
}

arguments();

while ($#ARGV >= 0) {
    $filename = shift @ARGV;
    open(FILE, $filename) || (die "Can't open $filename: $!\n");
    
    # discard path
    @data = split('/', $filename);
    pop(@data);

    processit(FILE, join('/', @data));
    
    close(FILE);
}

